%ext ck4
%version 1.4
# Load the modified graphics
%egahead EGAHEAD.CK4
%patch $10DEC $08 $00

#Load the custom maps
%gamemaps editmaps.ck4
%maphead maphead.ck4

#underwater level exits normally
#%patch $905B $90 $90

#Enemy Patches

#Bounder/Hipalong
#Jump height
%patch $111BC $DA $FF
# How high the Bounder leaps when shot while moving upward (default #is 32, which is $20h) 
%patch $11179 $40 

#mad mushroom/Hopper
# How many bounces until the "high" bounce
%patch $FF90 $02 $00 


#Oracle Members/key carriers
# Require only 7 members to be rescued. 
%patch $6AE6 $07 $7D 

#what oracle members say
%patch $30C17 "Alright! This is a key" $0A 
   "to Mort's base!  " $0A 
   "                 " $0A 
   "              " $0A 
   "           "

%patch $30BB3 "Alright! This is a key" $0A 
              "to Mort's base!  " $0A 
              "                 " $0A 
              "              " $0A 
              "                         "

#Keen's reply
%patch $30A71 "Now to look for more " $0A "keys!     " 

%patch $30A92 "I still need more  " $0A 
              "keys!       " $00 

%patch $30AB3 "Woo-hoo!    " $00

%patch $30AC0 "I wonder where       " $0A 
              "the rest of the    " $0A 
              "keys are?            " $00 

%patch $30B00 "I need more keys! " $00 

%patch $30B13 "I wonder where   " $0A 
              "the rest of the   " $0A 
              "keys are. " $00 

%patch $30B44 "Great, the last key!" $0A 

              "Mort is Toast!   " $00 

%patch $30B6B "This text shouldnt" $0A 
              "be here. Did you  " $0A 
              "modify the     " $0A 
              "patch file?    " $00





#Licks/Slurple
# Height for short hops 
%patch $113DA $C0 $FF  
# default is -32 
# Making this number smaller will make the Lick's leap less high, and shorter as a result.
# Height for long hops 
%patch $113F5 $E0 $FF  
# default is -16 
# Making this number smaller will make the Lick's leap taller, and longer as a result.

#eggs
# What comes out of the Eggs? 
%patch $10135 $F0 $23
%patch $10106 $00 $01  #80 #00


# You can make a line break with $0A 
# The story ends at $1F03B, so you can only have a story that's 507 bytes long. 
%patch $1EE40 "Episode Seven" 
$0A "        "
$0A "The Keys of Krodacia" 
$0A "        "
$0A "After learning that" 
$0A "his arch enemy"
$0A "Mortimer McMire is "
$0A "  still alive Commander  "
%patch 0x0001EEC6 "Keen looks for"
$0A "clues and makes the"
$0A "discovery that"
$0A "Mortimer plans to"
%patch 0x0001EF0A "destroy the Universe!"
$0A "                     "
$0A "Once at Mortimer's"
$0A "base, located"
$0A "on planet Krodacia,"
$0A "he"
%patch 0x0001EF6D " finds that the"
$0A "entrance to the base"
$0A "is locked."
$0A "The only way to"
$0A " open it is with "
%patch 0x0001EFBF "the seven keys of"
$0A "Krodacia. He must"
$0A "find the keys, the"
$0A "fate of the "
$0A "Universe is in"
$0A "his hands..." $00 $00


#Princess Lindsey



#Level where Lindsey gives the Miragia hint
%patch $EFB6 $06

#Level where Keen gives the Miragia reply instead of the Pyramid one: 
%patch $F033 $06 


%patch $30A25 "Lt. Barker says:     " $0A $00 
               
%patch $3094C "Thanks for rescuing " $0A
              "me! I would have jumped" $0A
              "out, but its too dark" $0A
              "in here!" $0A $00

%patch $30999 "You can get a swim    " $0A 
              "coin in Monk's house." $0A 
              "Good luck Commander " $0A 
              "Keen! " $0A $00 

%patch $309E3 "No problem. Lets go!  " $00 

%patch $309FA "Thanks for the" $0A 
              "good advice, Lt." $0A 
              "Barker!  " $0A $00

#How much Lindsey moves up/down 
%patch $12829 $00 $00 #Orig $08

#wetsuit
%patch $30A3D "I need a coin" $00 
 
%patch $30A4B "A swim coin! I bet I" $0A 
              "can use this!   " $00 

#level names
%patch $1F040 "Krodacia    " $00

%level.name 0 Krodacia
%level.entry 0 Keen explores\n planet Krodacia 

%level.name 1 Blue Forest
%level.entry 1 Keen wanders through \n the Blue Forest

%level.name 2 Forest Tunnels
%level.entry 2 Keen decends the\n Forest Tunnel

%level.name 3 Private Manor
%level.entry 3 Keen breaks \n into the Private Manor

%level.name 4 Mansion
%level.entry 4 Keen shoots his way \n through the Mansion          

%level.name 5 Complex
%level.entry 5 Keen sneaks into \n the complex         

%level.name 6 Mushroom Forest
%level.entry 6 Keen nervously enters\n the Mushroom Forest

%level.name 7 Cliff Hanger
%level.entry 7 Keen scales the\n Cliff Hanger

%level.name 8 The Underground
%level.entry 8 Keen wanders through\n the Underground

%level.name 9 Monk's House
%level.entry 9 Keen ransacks\n Monk's House

%level.name 10 Gem Temple
%level.entry 10 Keen purposefully\n enters the Gem Temple

%level.name 11 Forest Skies
%level.entry 11 Keen regrets going\n into the Forest Skies 

%level.name 12 Slime Temple
%level.entry 12 Keen dodges slime\n pools in the Slime Temple

%level.name 13 Fun House
%level.entry 13 Keen gets lost\n in the Fun House

%level.name 14 Stone Temple
%level.entry 14 Keen hesitently enters\n the Stone Temple

%level.name 15 Slime Lake
%level.entry 15 Keen takes a swim\n in Slime Lake

%level.name 16 Shoal
%level.entry 16 Keen dives into\n the Shoal 

%level.name 17  Reef
%level.entry 17 Keen treads water\n in the Reef


%patch $2F191 "Exit to Krodacia" $00


#menu patches
%patch $2F49C " Found "
%patch $2F4CB "Gems " 
%patch $2F4D1 " Coin  "


%patchfile $1fe47 ck4load.bin 

##musics##

#To patch AUDIODCT.CK4:
%patchfile $354F6 "AUDIODCT.CK4"

#To patch AUDIOHED.CK4:
%patchfile $20DF0 "AUDIOHED.CK4"

#00 SONG 157 On the Run
#04 SONG 161 Into the Inferno
#03 SONG 160 It's Quiet...Too Quiet
#02 SONG 159 Keen Rushin'
#01 SONG 158 Ceilick Vodoo
#FF SONG 162 The Key to Success



%patch $2F206 $00 $00 #Map       
              $03 $00 #Blue Forest      
              $01 $00 #Forest Tunnels     
              $04 $00 #Private Manor       
              $02 $00 #Mansion 
              $04 $00 #Complex   
              $03 $00 #Mushroom Forest      
              $01 $00 #Cliff Hangar    
              $02 $00 #Underground       
              $02 $00 #Monk's House       
              $01 $00 #Gem Temple   
              $03 $00 #Forest Skies    
              $04 $00 #Slime Temple  
              $02 $00 #Fun House 
              $04 $00 #Stone Temple 
              $03 $00 #Slime Lake   
              $02 $00 #Shoal
              $01 $00 #Reef
              $03 $00 #Bwb Megarocket
              $FF $FF #High scores



#Write custom CK4 TileInfo: 
%patchfile $249C2 keen4.tli


%patch $33234 "Commander Keen   " $00
%patch $33274 "Tom Hall         " $00
%patch $332B4 "Ceilick          " $00
%patch $332F4 "Keenrush         " $00
%patch $33334 "Levellass        " $00
%patch $33374 "Xky Rauh         " $00
%patch $333B4 "Adurdin          " $00
%patch $333F4 "Commander Spleen " $00



################################################################################
# Version Info
################################################################################

%patch $20D71	# Keen 4 startup screen
	"U" $1B
	"n" $1B
	"o" $1B
	"f" $1B
	"f" $1B
	"i" $1B
	"c" $1B
	"i" $1B
	"a" $1B
	"l" $1B
	" " $1B
	"B" $1B
	"u" $1B
	"g" $1B
	"f" $1B
	"i" $1B
	"x" $1B
	" " $1B
	"R" $1B
	"e" $1B
	"l" $1B
	"e" $1B
	"a" $1B
	"s" $1B
	"e" $1B
	" " $1B
	"(" $1B
	"2" $1B
	"0" $1B
	"2" $1B
	"0" $1B
	"-" $1B
	"0" $1B
	"9" $1B
	"-" $1B
	"2" $1B
	"1" $1B
	")" $1B


################################################################################
# Customized Screen Update Code For KEEN4 v1.4 (EGA)
# Copyright (c) 2019 K1n9_Duk3
#
# This software is provided 'as-is', without any express or implied warranty. In
# no event will the authors be held liable for any damages arising from the use
# of this software.
#
# Permission is granted to anyone to use this software for any purpose, including
# commercial applications, and to alter it and redistribute it freely, subject to
# the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not claim
#    that you wrote the original software. If you use this software in a product,
#    an acknowledgment in the product documentation would be appreciated but is
#    not required.
#
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.
################################################################################

#replace the v1.4 delay code with my custom VW_SetScreen code
#(my VW_SetScreen is bigger than the one in v1.4)
%patch $1E7F9
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$F7 $06 $7A14w $0001w	#	test	fixjerky, 1
	$74 $03			#	jz	@l3
	$E8 $0053w		#	call	WaitVBL
				#@l3:
	$F7 $06 $7ADEw $0001w	#	test	nopan, 1
	$75 $0C			#	jnz	l4
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
				#@l4:
	$F7 $06 $7A14w $0001w	#	test	fixjerky, 1
	$75 $03			#	jnz	@l5
	$E8 $0034w		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

#replace the start of VW_SetScreen with a jump into my new code (see above):
%patch $1E87A
	$E9 $FF7Cw

#and overwrite the rest of the old VW_SetScreen code with my WaitVBL code:
	$8B $1E $A53Dw		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $A53Dw		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn

################################################################################
# End of Customized Screen Update Code
################################################################################

##############################
# Load Audio Chunks Directly #
##############################

# This patch forces the game to load the audio data directly from the file into
# the final buffer without doing any Huffman decompression. This requires the
# AUDIO.CK4 file to be compressed with a "dummy" Huffman dictionary.
#
# Without this code, the game would load the "compressed" data into a temporary
# buffer and then decompress it into the final buffer. That means the memory
# requirements for music are more than TWICE(!) the size of the IMF song.

%patch $13466
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $76	$FE		#	push	bp+var_2
	$FF $76 $FC		#	push	bp+var_4
	$FF $36 $CB9Dw		#	push	audiohandle
	$9A $00001BC9rl		#	call	_lseek
	$83 $C4 $08		#	add	sp, 8
	$B8 $0004w		#	mov	ax, 4
	$50			#	push	ax
	$B8 $CB95w		#	mov	ax, offset chunkexplen
	$50			#	push	ax
	$FF $36 $CB9Dw		#	push	audiohandle
	$9A $00001F10rl		#	call	_read
	$83 $C4 $06		#	add	sp, 6
	$FF $36 $CB97w		#	push	word ptr chunkexplen+2
	$FF $36 $CB95w		#	push	word ptr chunkexplen
	$8B $C6			#	mov	ax, si
	$D1 $E0			#	shl	ax, 1
	$05 $C75Dw		#	add	ax, offset audiosegs
	$50			#	push	ax
	$9A $155E0712rl		#	call	MM_GetPtr
	$83 $C4 $06		#	add	sp, 6
	$83 $3E $A7EFw $00	#	cmp	mmerror, 0
	$75 $1E			#	jnz	done
	$FF $36 $CB97w		#	push	word ptr chunkexplen+2
	$FF $36 $CB95w		#	push	word ptr chunkexplen
	$8B $DE			#	mov	bx, si
	$D1 $E3			#	shl	bx, 1
	$FF $B7 $C75Dw		#	push	audiosegs[bx]
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $36 $CB9Dw		#	push	audiohandle
	$0E			#	push	cs
	$E8 $F68Bw		#	call	near ptr CA_FarRead
	$83 $C4 $0A		#	add	sp, 10
				#done:
	$5E			#	pop	si
	$8B $E5			#	mov	sp, bp
	$5D			#	pop	bp
	$CB			#	retf

# With this code, the huffman tree for the audio data is no longer needed,
# so let's prevent the engine from "optimizing" the huffman tree. This frees
# up 1024 bytes in the data segment, great for adding new (near) strings or
# new object state definitions.

# Free up 1024 bytes at $354F6 (dseg:6686):
%patch $13373 $EB $0F

	
########################################
# Free Graphics Before Loading A Level #
########################################

#Free sprites and tiles before loading a level
%patch $61DD
	$74 $0A			#	jz	no_demo
	$C7 $06 $7A6Cw $0002w	#	mov	gamestate_difficulty, 2
	$33 $C0			#	xor	ax, ax
	$EB $03			#	jmp	init_rndt
				#no_demo:
	$B8 $0001w		#	mov	ax, 1
				#init_rndt:
	$50			#	push	ax
	$9A $1D020002rl		#	call	US_InitRndT
	$58			#	pop	ax
	$9A $05C40006rl		#	call	FreeUpMemory
	$90 $90 $90 $90 $90 $90

#Don't free the paddle war sprites (in case loading a game fails)
%patch $5C4B $0081w	# default: $007Cw

##################
# Memory Related #
##################

# Fix error in XMS size calculation
%patch $157C2
	$BB $0010w	#	mov	bx, 16
	$F7 $E3		#	mul	bx
	$01 $06 $A017w	#	add	..., ax
	$11 $16 $A019w	#	adc	..., dx


# Lock text buffers to avoid "PageLayout: Text not headed with ^P" error

# CacheAndLock routine (returns grsegs offset in AX):
%patch $18793
	$55		#	push	bp
	$8B $EC		#	mov	bp, sp
	$57		#	push	di
	$8B $7E $06	#	mov	di, [bp+arg_0]
	$57		#	push	di
	$9A $12A61117rl	#	call	CA_CacheGrChunk
	$58		#	pop	ax
	$B8 $0001w	#	mov	ax, 1
	$50		#	push	ax
	$D1 $E7		#	shl	di, 1
	$81 $C7 $7AEDw	#	add	di, offset grsegs
	$57		#	push	di
	$9A $155e0AD5rl	#	call	MM_SetLock
	$83 $C4 $04	#	add	sp, 4
	$8B $C7		#	mov	ax, di
	$5F		#	pop	di
	$5D		#	pop	bp
	$CB		#	retf
# Note: this overwrites the unused SDL_TimingService code (2 bytes left unused)

# Use CacheAndLock instead of CA_CacheGrChunk to cache the text chunks
%patch $9BA8 $18740053rl	# for the help texts
%patch $9CBC $18740053rl	# for the ending text


# Make CA_UpLevel flow into CA_ClearMarks so we don't load more	than we need
%patch $13F4B $EB $30


#####################
# Underwater Levels #
#####################

# The following two patches allow you to use any number of underwater levels in
# a Keen 4 mod. Instead of checking if the current level number is 17, this
# makes the game check if the current level has a swimming Keen in it.
# Note that this will automatically disable the worldmap scrolling for level 17
# if that level has no swimming Keen in it.
#
# (lumpneeded for swimming Keen is at dseg:CB7B)

# always use worldmap scrolling when level has a swimming Keen:
%patch $9056
	$83 $3E $CB7Bw $00	#	cmp	lumpneeded, 0
	$75			#	jnz	...

# always use dead swimming Keen states when level has swimming Keen:
%patch $CC2A
	$83 $3E $CB7Bw $00	#	cmp	lumpneeded, 0
	$74			#	jz	...

%end